﻿using FM.LiveSwitch;

var client1 = new Client("https://cloud.liveswitch.io/", "<APPLICATIONID>");
var client2 = new Client("https://cloud.liveswitch.io/", "<APPLICATIONID>");

var token1 = Token.GenerateClientRegisterToken(client1, new ChannelClaim[] { new ChannelClaim("byteDataTransferTest") }, "<SHAREDSECRET>");
var token2 = Token.GenerateClientRegisterToken(client2, new ChannelClaim[] { new ChannelClaim("byteDataTransferTest") }, "<SHAREDSECRET>");

var channels = await client1.Register(token1);
var channel1 = channels[0];
channels = await client2.Register(token2);
var channel2 = channels[0];

var dataChannel1 = new DataChannel("test");
var dataChannel2 = new DataChannel("test");

var dataStream1 = new DataStream(dataChannel1);
var dataStream2 = new DataStream(dataChannel2);

var upConnection = channel1.CreateSfuUpstreamConnection(dataStream1, "mediaId");
var downConnection = channel2.CreateSfuDownstreamConnection("mediaId", dataStream2);

bool hasWrittenFile = false;
Func<bool> selector = () =>
{
    while (!hasWrittenFile)
    {
        Thread.Sleep(1000);
    }
    var txt = File.ReadAllText("Received.txt");
    Console.WriteLine("File Written.");
    Console.WriteLine(txt);
    return true;
};
var task = new Task<bool>(selector);


dataChannel1.OnStateChange += (DataChannel dc) =>
{
    if (dc.State == DataChannelState.Connected)
    {
        var file = File.ReadAllBytes("SendMe.txt");
        var wrapper = DataBuffer.Wrap(file);
        dc.SendDataBytes(wrapper);
    }
};

dataChannel2.OnReceive += (DataChannelReceiveArgs args) =>
{
    if (args.DataBytes != null)
    {
        File.WriteAllBytes("Received.txt", args.DataBytes.ToArray());
        hasWrittenFile = true;
    }
};

await downConnection.Open();
await upConnection.Open();

task.Start();
Task.WaitAny(new Task[] { task });
//Console.ReadLine();